<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Home - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="Measure.html">Measure</a><ul class='methods'><li data-type='method' style='display: none;'><a href="Measure.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="Measure.html#add">add</a></li><li data-type='method' style='display: none;'><a href="Measure.html#asString">asString</a></li></ul></li><li><a href="webcontrols.html">webcontrols</a><ul class='members'><li data-type='member' style='display: none;'><a href="webcontrols.html#.verbose">verbose</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="webcontrols.html#.addButtonOnOff">addButtonOnOff</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.addButtonRange">addButtonRange</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.addConsole">addConsole</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.consoleLog">consoleLog</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.loadJSON">loadJSON</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.consoleClear">consoleClear</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.curl">curl</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#answer">answer</a></li><li><a href="global.html#gpio_digital_timing_start">gpio_digital_timing_start</a></li><li><a href="global.html#gpio_digital_timing_stop">gpio_digital_timing_stop</a></li><li><a href="global.html#gpio_digital_timing_get">gpio_digital_timing_get</a></li><li><a href="global.html#setInterval">setInterval</a></li></ul>
    
</nav>

<div id="main">
    

    



    


    <section class="package">
        <h3> </h3>		
    </section>









    



    <section class="readme usertext">
        <article><h1>esp32gpiocontrol</h1>
<p>ESP32 firmware providing a REST API for controlling the GPIO interface and higher functions</p>
<div style='float:right;margin-left:20px'><a target=_blank' href='https://line.gitlabpages.inria.fr/aide-group/aide/index.html'><img alt='AIDE API docs' src='https://line.gitlabpages.inria.fr/aide-group/aide/img/icons8-api-aide.png'/></a></div>
<p>Please refer to the usual ESP32/Arduino <a href="https://www.arduino.cc/reference/en">language reference</a> for usual functions documentation.</p>
<h2>A tiny framework for ESP32 connected objects</h2>
<p>This software package provides a minimal set of functionalities to develop a connected object using a <a href="https://en.wikipedia.org/wiki/ESP32">ESP32</a> micro-controller.</p>
<p>In a nutshell:</p>
<ul>
<li>The object has a <a href="https://en.wikipedia.org/wiki/General-purpose_input/output">GPIO</a> interface with digital and analog inputs and outputs and the capability to measure times, or connect to additional control board to drive, e.g., servomotors.</li>
<li>It is connected to the (human or machine) user via a WiFi interface, as a web service, i.e., is driven using <a href="https://en.wikipedia.org/wiki/URL">URL</a>.</li>
<li>It is programmed via an USB interface connected on a computer with an Arduino IDE development tool.</li>
</ul>
<p>In order to ease such connected object development, we propose here:</p>
<ul>
<li>The EPS32 IDE environment and the esp32gpiocontrol software as <a href="https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/blob/master/src/install_esp32.md">documented here</a>.</li>
<li>The <a href="https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/blob/master/src/usage_more.md">how-to documentation</a> to develop specific connected objects.</li>
<li>A GPIO control package also interesting as a development example, including the HTML interface for end user <a href="https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/blob/master/src/usage_gpio.md">documented here</a>:</li>
</ul>
<p><img src="https://line.gitlabpages.inria.fr/aide-group/esp32gpiocontrol/setup_gpio_page.png" alt="HTML web interface" title="HTML web interface"></p>
<p><a name='what'></a></p>
<h2>Package repository</h2>
<ul>
<li>Package files: <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol'>https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol</a></li>
<li>Package documentation: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/esp32gpiocontrol'>https://line.gitlabpages.inria.fr/aide-group/esp32gpiocontrol</a></li>
<li>Source files: <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/tree/master/src'>https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/tree/master/src</a></li>
<li>Saved on <a target='_blank' href='https://archive.softwareheritage.org/browse/origin/directory/?origin_url=https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol'>softwareherirage.org</a></li>
<li>Version <code>1.1.1</code></li>
<li>License <code>CECILL-C</code></li>
</ul>
<h2>Installation</h2>
<h3>User simple installation</h3>
<ul>
<li><code>npm install git+https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol.git</code></li>
</ul>
<h3>Co-developper installation</h3>
<ul>
<li>See the <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild/install.html#.install_as_developer'>related documentation</a></li>
</ul>
<p>Please refer to the <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild/install.html'>installation guide</a> for installation.</p>
<p><a name='how'></a></p>
<h2>Usage</h2>
<ul>
<li>Refer to <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/blob/master/src/install_esp32.md'>install_esp32</a>, for the installation.,- Refer to <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/blob/master/src/usage_gpio.md'>usage_gpio</a>, for the GPIO web service usage.,- Refer to <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/blob/master/src/usage_more.md'>usage_more</a>, to get help implementing new functionalities.,</li>
</ul>
<h3>npm script usage</h3>
<pre class="prettyprint source"><code>npm install --quiet : installs all package dependencies and sources.
npm run build: builds the different compiled, documentation and test files.
npm test     : runs functional and non-regression tests.
npm run clean: cleans installation files.
</code></pre>
<p><a name='dep'></a></p>
<h2>Dependencies</h2>
<ul>
<li>None</li>
</ul>
<h2>devDependencies</h2>
<ul>
<li><tt>aidebuild: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild'>Builds multi-language compilation packages and related documentation.</a></tt></li>
</ul>
<p><a name='who'></a></p>
<h2>Authors</h2>
<ul>
<li>Éric Pascual  <big><a target='_blank' href='mailto:eric.g.pascual@gmail.com'>🖂</a></big>  <big><a target='_blank' href='https://twitter.com/ericpobot'>🗏</a></big></li>
<li>Thierry Viéville  <big><a target='_blank' href='mailto:thierry.vieville@inria.fr'>🖂</a></big></li>
</ul></article>
    </section>






    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>